
;---------------------------------------------
;	Double - PureBasic Library V1.00
;=============================================
;	    Written by Roger Beausoleil
;	      visionfx@satelcom.qc.ca
;	            March 2002
;---------------------------------------------


;---------------------------------------------
;	  PureBasic Functions Declarations
;---------------------------------------------

	GLOBAL	PB_MakeFloatDouble
	GLOBAL	PB_DoubleHigh
	GLOBAL	PB_DoubleLow
	GLOBAL	PB_DoubleToFloat
	GLOBAL	PB_DoubleAddition

;---------------------------------------------
;	       External Functions Call
;---------------------------------------------


;---------------------------------------------
;	Call Macro Declarations as 'C'
;---------------------------------------------
;---------------------------------------------
;	            The Pure Code
;---------------------------------------------

	SEGMENT	.text	USE32	CLASS=CODE

PB_MakeFloatDouble:
	Fstp	QWord [ Double ]
	Xor	Eax,Eax
	Ret 4

PB_DoubleHigh:
	Mov	Eax,DWord [ Double ]
	Ret

PB_DoubleLow:
	Mov	Eax,DWord [ Double + 4 ]
	Ret 

PB_DoubleToFloat:
	Mov	DWord[ Double ],Eax
	Mov	Eax,DWord [ Esp+4 ]
	Mov	DWord[ Double + 4 ],Eax
	Fld	QWord[ Double ]
	Ret   4

PB_DoubleAddition:
	Fclex
	Mov	DWord[ Double ],Eax
	Mov	Eax,DWord [ Esp+12 ]
	Mov	DWord[ Double + 4 ],Eax
	Fld	QWord[ Double ]

	Mov	Eax,Dword[ Esp+8 ]
	Mov	Dword[ Double ],Eax
	Mov	Eax,DWord [ Esp+4 ]
	Mov	DWord [ Double + 4 ],Eax
	Fld	QWord [ Double ]

	Faddp	St1,St0
	Fst	QWord [ Double ]
	Ret	12
;---------------------------------------------
;	        Variable Declarations
;---------------------------------------------

		SEGMENT	.data	CLASS=DATA
Double:	dd	0		; High
		dd	0		; Low

